#include<iostream>



#include "Event_handler.h"

#include "Event.h"



int Event_handler::s_verbose_level = 0;

Event_handler::Event_queue Event_handler::s_queue;



/*!

 */

void Event_handler::process()

{

  if (s_verbose_level >= 2)

    std::cout << "Event_handler::process()" << std::endl;

  

  while (!s_queue.empty()) {

    Event * event = s_queue.front();

    s_queue.pop();

    // event->identify();

    event->handle();

    delete event;

  }

}



/*!

 */

void Event_handler::issue(Event * event) { s_queue.push(event); }



/*!

 */

bool Event_handler::is_empty(void) { return s_queue.empty(); }

