#ifndef EVENT_HANDLER_H

#define EVENT_HANDLER_H



/*! \file eventHandler.h

 * \brief event handling.

 */



#include <time.h>

#include <queue>



class Event;



/*!

 */ 

class Event_handler {

public:

  void process();

  static void issue(Event * event);



  /*!

   */

  static void set_verbose_level(int verbose_level)

  { s_verbose_level = verbose_level; }



  /*!

   */

  static bool is_empty(void);

  

private:

  static int s_verbose_level;



  typedef std::queue<Event *> Event_queue;

  static Event_queue s_queue;

};



#endif

