#if (defined _MSC_VER)

#include <windows.h>

#endif

#include <GL/gl.h>

#include <iostream>



#include "Robot_ref.h"

#include "Vector2f.h"



/*!

 */

Robot_ref::Robot_ref(void) :

  m_radius(1)

{

  m_point[0] = m_point[1] = 0;



  m_color[0] = 0.0;

  m_color[1] = 0.0;

  m_color[2] = 0.0;

  m_color[3] = 1.0;

}



/*!

 */

void Robot_ref::set_point(const Vector2f & point)

{

  m_point[0] = point[0];

  m_point[1] = point[1];

}



/*!

 */

void Robot_ref::draw(void)

{

  glColor4fv((float*)&m_color);

  Circle::draw(m_point, m_radius);

}

