#include <iostream>



#include "Robot_ref_sim.h"

#include "Reshape_viewport_events.h"



/*!

 */

Robot_ref_sim::Robot_ref_sim(void) :

  m_radius(4.0f)

{

  Reshape_cs_viewport_event::doregister(this);

}



/*!

 */

void Robot_ref_sim::handle(Reshape_cs_viewport_event * reshape_event)

{

  float win_scale = reshape_event->get_win_scale();

  Robot_ref::set_radius(m_radius * win_scale);

}



/*!

 */

void Robot_ref_sim::identify(void) { std::cout << "Robot_ref_sim" << std::endl; }

