#ifndef TRANS_POLY_SIM_CIRCULAR_SEARCH_H
#define TRANS_POLY_SIM_CIRCULAR_SEARCH_H

#include "Agent.h"
#include "Trans_poly_circular_search.h"
#include "Reshape_viewport_events.h"

class Trans_poly_sim_circular_search  :
  public Agent, public Trans_poly_circular_search
{
private:
  float m_arrow_length;         // measured in pixels
  float m_arrow_width;          // measured in pixels

public:
  /*!
   */
  Trans_poly_sim_circular_search();
  
  /*!
   */
  virtual ~Trans_poly_sim_circular_search();
  
  /*!
   */
  virtual void identify(void);

  /*!
   */
  virtual void handle(Reshape_ds_viewport_event * reshape_event);
};

#endif
