#include "UtilitiesPch.h"



#include "Vector2sh.h"



short & EVector2sh::operator[](int i) 

{

    return m_vector[i];

}



short EVector2sh::operator[](int i) const 

{

    return m_vector[i];

}



void EVector2sh::Set(short a, short b) 

{

    m_vector[0] = a; m_vector[1] = b; 

}



void EVector2sh::Get(short *a, short *b)  const 

{

    *a = m_vector[0]; *b = m_vector[1];

}



short EVector2sh::Get(int i) const 

{

    if (i == 0 || i == 1) return m_vector[i];

    else return 0;   // !!!!!!!! SHould WARN !!!!!!!!!!

}



void EVector2sh::Set(const EVector2sh &v) 

{

    m_vector[0] = v.m_vector[0]; m_vector[1] = v.m_vector[1];

}



void EVector2sh::Get(EVector2sh &v) const

{

    v.m_vector[0] = m_vector[0];  v.m_vector[1] = m_vector[1];

}



void EVector2sh::Add(const EVector2sh & _v1, const EVector2sh & _v2) 

{ 

    m_vector[0] = _v1[0] + _v2[0]; 

    m_vector[1] = _v1[1] + _v2[1]; 

}



EVector2sh::EVector2sh()

{

    m_vector[0] = m_vector[1] = 0;

}



EVector2sh::EVector2sh(short a, short b)

{

    Set(a, b);

}



EVector2sh::EVector2sh(const EVector2sh & v)

{

    Set(v[0], v[1]);

}



void EVector2sh::Sub(const EVector2sh & _v1, const EVector2sh & _v2) 

{ 

    m_vector[0] = _v1[0] - _v2[0]; 

    m_vector[1] = _v1[1] - _v2[1]; 

}



/*void EVector2sh::Add(const EVector2sh & _v) 

{ 

    m_vector[0] += _v[0]; 

    m_vector[1] += _v[1]; 

}*/

/*bool EVector2sh::Equal(const EVector2f &  _v) const 

{ 

    return (m_vector[0] == _v[0] && m_vector[1] == _v[1]);

}



void EVector2f::Negate(const EVector2f & _v) 

{ 

    m_vector[0] = -_v[0];

    m_vector[1] = -_v[1]; 

}



EFloat EVector2f::Dot(const EVector2f &  _v) const 

{

    return (m_vector[0] * _v[0] + m_vector[1] * _v[1]);

}













void EVector2f::Sub(const EVector2f & _v) 

{ 

    m_vector[0] -= _v[0]; 

    m_vector[1] -= _v[1]; 

}



void EVector2f::Scale(EFloat _s, const EVector2f & _v) 

{ 

    m_vector[0] = _s * _v[0];

    m_vector[1] = _s * _v[1];

}



void EVector2f::Scale(EFloat _s) 

{ 

    m_vector[0] *= _s ;

    m_vector[1] *= _s ;

}



void EVector2f::AddScaled(const EVector2f & _v1, EFloat _s,

                                   const EVector2f & _v2) 

{ 

    m_vector[0] = _v1[0] + _s * _v2[0]; 

    m_vector[1] = _v1[1] + _s * _v2[1]; 

}



void EVector2f::Combine(EFloat _a, const EVector2f & _v1,

                                 EFloat _b, const EVector2f & _v2) 

{ 

    m_vector[0] = _a * _v1[0] + _b * _v2[0]; 

    m_vector[1] = _a * _v1[1] + _b * _v2[1]; 

}



EFloat EVector2f::SqrDistance(const EVector2f & v) const 

{ 

    EFloat d0, d1;

    d0 = m_vector[0] - v.m_vector[0];

    d1 = m_vector[1] - v.m_vector[1];

    return d0 * d0 + d1 * d1;

}



EFloat EVector2f::Length() const

{

//    return immSqrtf(Dot(*this));

	return 0;

}



EVector2f & EVector2f::operator=(const EVector2f & v) 

{

    Set(v); return *this;

}



EVector2f & EVector2f::operator=(EFloat v) 

{

    m_vector[0] = v; m_vector[1] = v;

    return *this;

}



bool EVector2f::operator==(const EVector2f & v) const

{

    return Equal(v);

}



bool EVector2f::operator!=(const EVector2f & v) const 

{

    return !Equal(v);

}







// =======================================================================

// EVector2f::Round

// =======================================================================

inline void EVector2f::Round()

{

    m_vector[0] = (int)m_vector[0]; 

	m_vector[1] = (int)m_vector[1]; 

	

}



// =======================================================================

// Mul

// =======================================================================

inline void EVector2f::Mul(const EVector2f & v1, const EVector2f & v2)

{

    m_vector[0] = v1[0] * v2[0];

    m_vector[1] = v1[1] * v2[1];

}



// =======================================================================

// Div

// =======================================================================

inline void EVector2f::Div(float c, const EVector2f & v)

{

    m_vector[0] = c / v[0];

    m_vector[1] = c / v[1];

}

*/