#if (defined _MSC_VER)
#include <windows.h>
#endif
#include <GL/gl.h>

#include "Viewport.h"

/*!
 */
Viewport::Viewport(void) :
  m_left(DEF_LEFT), m_bottom(DEF_BOTTOM),
  m_width(DEF_WIDTH), m_height(DEF_HEIGHT)
{}

/*!
 */
void Viewport::set(int left, int bottom, int width, int height)
{
  set_position(left, bottom);
  set_dimension(width, height);
}

/*!
 */
void Viewport::set_position(int left, int bottom)
{
  m_left = left;
  m_bottom = bottom;;
}

/*!
 */
void Viewport::set_dimension(int width, int height)
{
  m_width = width;
  m_height = height;
}

/*!
 */
void Viewport::operator()(void) const
{
  glViewport(m_left, m_bottom, m_width, m_height);
}
