#ifndef AGENT_H
#define AGENT_H

#include "Reshape_viewport_events.h"

class Tick_event;
class Mouse_event;
class Motion_event;
class Mouse_ws_event;
class Rotate_event;
class Translate_event;
class Translate_robot_event;
class Collision_test_event;
class Extreme_vertices_event;
class Highlight_normals_event;
class Highlight_edge_event;
class Mode_event;
class Simulate_event;
class Stop_event;
class Reset_event;

class Agent {
public:
  virtual void handle(Tick_event *) {}
  virtual void handle(Mouse_event *) {}
  virtual void handle(Motion_event *) {}
  virtual void handle(Mouse_ws_event *) {}
  virtual void handle(Reshape_ws_viewport_event *) {}
  virtual void handle(Reshape_cs_viewport_event *) {}
  virtual void handle(Reshape_as_viewport_event *) {}
  virtual void handle(Reshape_ds_viewport_event *) {}
  virtual void handle(Rotate_event *) {}
  virtual void handle(Translate_event *) {}
  virtual void handle(Translate_robot_event *) {}
  virtual void handle(Collision_test_event *) {}
  virtual void handle(Extreme_vertices_event *) {}
  virtual void handle(Highlight_normals_event *) {}
  virtual void handle(Highlight_edge_event *) {}
  virtual void handle(Mode_event *) {}
  virtual void handle(Simulate_event *) {}
  virtual void handle(Stop_event *) {}
  virtual void handle(Reset_event *) {}

  virtual void identify(void) = 0;
};

#endif
