#ifndef EVENT_H

#define EVENT_H



#include <set>



class Agent;



/*!

 */

class Event {

private:

  int m_verbose_level;



  virtual void handle(Agent * agent) = 0;

  virtual const std::set<Agent *> & get_set(void) const = 0;



public:

  /*!

   */

  Event() : m_verbose_level(0) {}



  /*!

   */

  virtual ~Event() {}



  /*!

   */

  virtual void identify(void) = 0;

  

  /*!

   */

  void handle(void);



  /*!

   */

  void set_verbose_level(int verbose_level) { m_verbose_level = verbose_level; }

};



#endif

