#ifndef PARSE_MAIN_CL_H
#define PARSE_MAIN_CL_H

#include <iostream>
#include "Parse_command_line.h"
#include "Dir_search.h"

/*!
 */
class Parse_main_cl : public Parse_command_line {
public:
  /*!
   */
  Parse_main_cl(int argc, char * argv[]);
  
  /*!
   */
  virtual void print_help(void);

  /*!
   */
  virtual int operator()(void);

  /*!
   */
  virtual char * get_option_str(void) const { return s_option_str; }
  
  /*!
   */
  int get_verbose_level() const { return m_verbose_level; }

private:
  static char s_option_str[];
  int m_verbose_level;

  Dir_search m_dirs;
};

#endif

