#ifndef ROBOT_REF_H

#define ROBOT_REF_H



#include "Circle.h"

#include "Vector2f.h"

#include "Vector4f.h"



class Robot_ref : public Circle {

protected:

  RGBA_color m_color;

  Vector2f m_point;

  float m_radius;

  

public:

  /*!

   */

  Robot_ref(void);

  

  /*!

   */

  void set_radius(float radius) { m_radius = radius; }



  /*!

   */

  void set_point(const Vector2f & point);



  /*!

   */

  void draw(void);

};



#endif

