#ifndef SCEME_H
#define SCEME_H

#include "Agent.h"

class Scene : public Agent {
public:
  virtual void init(void) = 0;
  virtual void draw(void) = 0;
  virtual void reshape(int width, int height) = 0;
  virtual void destroy(void) {}
  virtual void print_help(void) {}
  virtual void keyboard(unsigned char c, int x, int y) {}
};

#endif
