#include <iostream>

#include "Trans_poly_sim_circular_search.h"

/*!
 */
Trans_poly_sim_circular_search::Trans_poly_sim_circular_search() :
  m_arrow_length(20), m_arrow_width(10)
{
  Reshape_ds_viewport_event::doregister(this);
}
  
/*!
 */
Trans_poly_sim_circular_search::~Trans_poly_sim_circular_search()
{
  Reshape_ds_viewport_event::unregister(this);
}
  
/*!
 */
void Trans_poly_sim_circular_search::identify(void)
{
  std::cout << "Agent: Trans_poly_sim_circular_search" << std::endl;
}

/*!
 */
void Trans_poly_sim_circular_search::
handle(Reshape_ds_viewport_event * reshape_event)
{
  float win_scale = reshape_event->get_win_scale();
  Trans_poly_circular_search::set_arrow_length(m_arrow_length * win_scale);
  Trans_poly_circular_search::set_arrow_width(m_arrow_width * win_scale);
}
