#ifndef BOUNDING_BOX_2F_H

#define BOUNDING_BOX_2F_H



#include "Iso_rectangle.h"



class BBox_2f : public Iso_rectangle<float> {

public:

  /*!

   */

  BBox_2f() {}



  /*!

   */

  void add(float x, float y)

  {

    if (x < m_vector[0]) m_vector[0] = x;

    if (y < m_vector[1]) m_vector[1] = y;

    if (x > m_vector[2]) m_vector[2] = x;

    if (y > m_vector[3]) m_vector[3] = y;

  }

  

  /*!

   */

  void add(const Vector2f & p) { add(p[0], p[1]); }



  /*!

   */

  void operator=(const BBox_2f & bb)

  {

    //! \todo How do I refer to the '=' operator of the base class?

    m_vector[0] = bb.m_vector[0];

    m_vector[1] = bb.m_vector[1];

    m_vector[2] = bb.m_vector[2];

    m_vector[3] = bb.m_vector[3];

  }

  

  /*!

   */

  void operator+=(const BBox_2f & bb)

  {

    if (bb.m_vector[0] < m_vector[0]) m_vector[0] = bb.m_vector[0];

    if (bb.m_vector[1] < m_vector[1]) m_vector[1] = bb.m_vector[1];

    if (bb.m_vector[2] > m_vector[2]) m_vector[2] = bb.m_vector[2];

    if (bb.m_vector[3] > m_vector[3]) m_vector[3] = bb.m_vector[3];

  }



  /*!

   */

  float get_minx(void) const { return m_vector[0]; }

  float get_miny(void) const { return m_vector[1]; }

  float get_maxx(void) const { return m_vector[2]; }

  float get_maxy(void) const { return m_vector[3]; }

};



#endif

