#include <assert.h>



#include "Plane.h"

#include "Matrix4f.h"

#include "Vector3f.h"



#if 0

/*!

 */

unsigned int Plane::contains(const EBoxBound * box) const

{

  (void) box;

  assert(0);

  return 0;

}



/*!

 */

unsigned int Plane::contains(const ESphereBound * sph) const

{

  (void) sph;

  assert(0);

  return 0;

}



/*!

 */

unsigned int Plane::Isect(const Seg * seg, float * d) const

{

  (void) seg, d;

  assert(0);

  return 0;

}



/*!

 */

unsigned int Plane::Isect(const ESeg * seg, float * d1, float * d2) const

{

  (void) seg, d1, d2;

  assert(0);

  return 0;

}

#endif



/*! Stores in this half space the result of transforming <pln> by the

 * ortho transform <m>.

 */

void Plane::ortho_xform(const Plane * pln, const Matrix4f & mat)

{

  (void) pln, (void) mat;

  assert(0);

}



/*! Constructs a plane from the three points <p1> <p2>, and <p3>,

 * assuming they form a counter-clockwise triangle viewed from the front.

 */

void Plane::make_pts(const Vector3f & p1, const Vector3f & p2,

                     const Vector3f & p3)

{

  Vector3f t1;

  Vector3f t2;

  t1.sub(p2,p1);

  t2.sub(p3,p2);

  m_normal.cross(t1,t2);

  m_normal.normalize();

  m_offset = p2.dot(m_normal);

}



/*! Stores the normal-point representation of the plane in norm and point.

 */

void Plane::make_norm_pt(const Vector3f & norm, const Vector3f & pos)

{

  m_normal.set(norm);

  m_normal.normalize();

  m_offset = pos.dot(m_normal);

}



/*! Stores in <dst> the point on this plane closest to <pt>.

 */

void Plane::closest_pt_on(const Vector3f & pt, Vector3f & dst) const

{

  float scale = -m_normal.dot(pt) - m_offset;

  dst.add_scaled(pt, scale, m_normal);

}

